Index: /trunk/seguranca/certificados.js
===================================================================
--- /trunk/seguranca/certificados.js	(revision 1035)
+++ /trunk/seguranca/certificados.js	(revision 1035)
@@ -0,0 +1,169 @@
+   var num = 0;
+   var titulo = '';
+   
+function msgWin(msg,w,h,params)
+	{
+		var winl = (screen.width - w ) / 2;
+		var wint = (screen.height - h) / 2;	
+		var parm = "width=" + w + ",height=" + h + ",top=" + wint + ",left=" + winl + params;
+		win3 = window.open("","12345" + num,parm); 
+		num = num + 1;				
+		win3.document.writeln(msg);
+		win3.focus();
+	}
+
+  function Um_Certificado(valor) 
+	{	
+		if(valor.length < 2) { return; }
+		//verifica se o browser tem suporte a ajax
+		try 
+			{
+				ajax = new ActiveXObject("Microsoft.XMLHTTP");
+			} 
+		catch(e) 
+			{
+				try 
+					{
+						ajax = new ActiveXObject("Msxml2.XMLHTTP");
+					}
+				catch(ex) 
+					{
+						try 
+							{
+								ajax = new XMLHttpRequest();
+							}
+						catch(exc) 
+							{
+								alert("Esse browser não tem recursos para uso do Ajax");
+								ajax = null;
+							}
+					}
+			}
+
+		//se tiver suporte ajax
+		if(ajax) 
+			{
+				titulo = valor;
+				ajax.open("POST", "certs_xml.php", true);
+				ajax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
+				ajax.onreadystatechange = function() 
+											{
+												//enquanto estiver processando...emite a msg de carregando
+												//if(ajax.readyState == 1) 
+												//	{
+												//		//idOpcao.innerHTML = "Obtendo Certificados ...! ";   
+												//	}
+												//após ser processado - chama função processa_um_certificado que vai varrer os dados
+												if(ajax.readyState == 4 ) 
+													{
+														if(ajax.responseXML) 
+															{
+																processa_um_certificado(ajax.responseXML);
+															}
+														else 
+															{
+																//caso não seja um arquivo XML emite a mensagem abaixo
+																msg = 'N&atilde;o foi poss&iacute;vel obter dados do certificado.' + '<br/><br/><div align="center"><INPUT type="button" value="Fechar" onClick="window.close()">';
+																parms = ",scrollbars=1";
+																msgWin(msg,450,200,parms)
+															}
+													}
+											}
+				//passa o código do certificado desejado...
+				var params = "id="+valor;
+				ajax.send(params);
+			}
+	}
+      
+   function processa_um_certificado(obj)
+	{
+	        // Tab com tags que deve exibir sho o nome....
+	        var TBtags = new Array( "EMISSOR_CAMINHO_COMPLETO", "SUBJECT" , "CRLDISTRIBUTIONPOINTS" , "KEYUSAGE" );
+		//pega a tag certificado
+		var dataArray   = obj.getElementsByTagName("certificado");
+		//total de elementos contidos na tag 
+		if(dataArray.length > 0)
+			{
+				var novo = "<head><title>" + titulo + "</title></head><body><font size=2><h3 align=center ><font color=#0000EE>Dados do certificado</font></h3>";
+				//percorre o arquivo XML para extrair os dados
+				for(var i = 0 ; i < dataArray.length ; i++) 
+					{
+						var item = dataArray[i];
+						var cc    =  item.getElementsByTagName("*");
+						len = 0;
+						for(var j = 0 ; j < cc.length ; j++) 
+							{
+								//contéudo dos campos no arquivo XML
+								var tag = cc[j].nodeName
+								if(tag == "CA") continue; // skipa tag CA .... 
+								var xflag = 0;
+								for(var iz = 0;iz< TBtags.length;iz++)
+									{
+										if(TBtags[iz] == tag) xflag = 1;
+									}
+								 // Testa se deve exibir o valor da tag..
+								if(xflag ==1 )
+									{
+										var nome    =   "<b>" +tag +":</b> ";
+									}
+								else
+									{
+									        // Testa o browser para usar a propriedade  correta ...
+										if (navigator.userAgent.match('MSIE'))
+											{
+												var conteudo = cc[j].text;
+											}
+										else
+											{
+												var conteudo = cc[j].textContent;
+											}
+										
+										if(conteudo == "1") 
+											{
+												conteudo = "Sim.";
+											}
+											
+										if(conteudo == "") 
+											{
+												conteudo = "N&atilde;o.";
+											}	
+											
+										switch(tag)
+											{
+											
+												case "INICIO_VALIDADE":
+													{
+														var aux = conteudo.substr(0,4) + "/" + conteudo.substr(4,2) + "/" + conteudo.substr(6,2)  + "  -  " + conteudo.substr(8,2)  + ":" + conteudo.substr(10,2)  + ":" + conteudo.substr(12,2)  + " GMT";
+														conteudo = aux;
+														break;
+													}
+												case "FIM_VALIDADE":
+													{
+														var aux = conteudo.substr(0,4) + "/" + conteudo.substr(4,2) + "/" + conteudo.substr(6,2)  + "  -  " + conteudo.substr(8,2)  + ":" + conteudo.substr(10,2)  + ":" + conteudo.substr(12,2)  + " GMT";
+														conteudo = aux;
+														break;
+													}
+												default:
+													{
+														break;
+													}
+											}
+										var nome    =  "<b>" + tag +":</b> " + conteudo;
+									}
+								novo = novo + nome + '<br/>';
+								len = len + 24;
+							}
+					}
+				msg = novo + '<br/><br/><div align="center"><INPUT type="button" value="Fechar" onClick="window.close()"></font></body>';
+			}
+		else 
+			{
+				//caso o XML volte vazio, printa a mensagem abaixo
+				msg = 'N&atilde;o foi poss&iacute;vel obter dados do certificado.' + '<br/><br/><div align="center"><INPUT type="button" value="Fechar" onClick="window.close()"></font></body>';
+				len =200;
+			}
+		parms = ",scrollbars=1";
+		num = num + 1;				
+		msgWin(msg,450,len,parms)
+	}
+
Index: /trunk/expressoMail1_2/setup/phpgw_en.lang
===================================================================
--- /trunk/expressoMail1_2/setup/phpgw_en.lang	(revision 799)
+++ /trunk/expressoMail1_2/setup/phpgw_en.lang	(revision 1035)
@@ -14,4 +14,7 @@
 all	expressoMail1_2	en	all
 Also check message against next rule	expressoMail1_2	en	Also check message against next rule
+Always sign message digitally?	expressoMail1_2	en	Always sign message digitally?
+Always cipher message digitally?	expressoMail1_2	en	Always cipher message digitally?
+and	expressoMail1_2	en	and
 and save in	expressoMail1_2	en	and save in
 Answered	expressoMail1_2	en	Answered
@@ -21,4 +24,5 @@
 At %1, %2 hours, %3 wrote:	expressoMail1_2	en	At %1, %2 hours, %3 wrote:
 Auto save draft	expressoMail1_2	en	Auto save draft
+authentic	expressoMail1_2	en	authentic
 Back	expressoMail1_2	en	Back
 BCC	expressoMail1_2	en	BCC
@@ -33,4 +37,8 @@
 CC	expressoMail1_2	en	CC
 CCo	expressoMail1_2	en	CCo
+REVOKED Certificate.	expressoMail1_2	en	REVOKED Certificate.
+Certificate Authority: 	expressoMail1_2	en	Certificate Authority:
+Certificate email: 	expressoMail1_2	en	Certificate email:
+certificate has expired	expressoMail1_2	en	certificate has expired
 Change folder	expressoMail1_2	en	Change folder
 Choose a name	expressoMail1_2	en	Choose a name
@@ -44,4 +52,8 @@
 Command for unmark spam	admin	en	Command for unmark spam
 Config for ExpressoMail	expressoMail1_2	en	Config for ExpressoMail
+Couldn't verify if certificate was revoked.(CD-01)	expressoMail1_2	en	Couldn't verify if certificate was revoked.(CD-01)
+Couldn't verify if certificate was revoked.(CD-02)	expressoMail1_2	en	Couldn't verify if certificate was revoked.(CD-02)
+Couldn't verify if certificate was revoked.(CD-03)	expressoMail1_2	en	Couldn't verify if certificate was revoked.(CD-03)
+Crypted message	expressoMail1_2	en	Crypted message
 Cyrus IMAP Server	expressoMail1_2	en	Cyrus IMAP Server
 attachment	expressoMail1_2	en	attachment
@@ -59,4 +71,7 @@
 DISABLED	expressoMail1_2	en	DISABLED
 Disable	expressoMail1_2	en	Disable
+Details	expressoMail1_2	pt-br	Details
+Digitally sign message?	expressoMail1_2	en	Digitally sign message?
+Digitally crypt message?	expressoMail1_2	en	Digitally crypt message?
 Download all atachments	expressoMail1_2	en	Download all atachments
 Download manual	expressoMail1_2	en	Download manual
@@ -79,4 +94,5 @@
 ENABLED	expressoMail1_2	en	ENABLED
 Enable	expressoMail1_2	en	Enable
+Enable digitally sign/cipher the message?	expressoMail1_2	en	Enable digitally sign/cipher the message?
 Enable Quick Reply	expressoMail1_2	en	Enable Quick Reply
 Enter a name for the box	expressoMail1_2	en	Enter a name for the box
@@ -88,4 +104,10 @@
 Error in SMTP sending read confirmation.	expressoMail1_2	en	Error in SMTP sending read confirmation.
 Error moving message.	expressoMail1_2	en	Error moving message.
+Enable digitally sign/cipher the message?	expressoMail1_2	en	Enable digitally sign/cipher the message?
+#error:21075075:PKCS7 routines:PKCS7_verify:certificate verify error	expressoMail1_2	en	#error:21075075:PKCS7 routines:PKCS7_verify:certificate verify error
+error:21075069:PKCS7 routines:PKCS7_verify:signature failure	expressoMail1_2	en	error:21075069:PKCS7 routines:PKCS7_verify:signature failure
+error:21071065:PKCS7 routines:PKCS7_signatureVerify:digest failure	expressoMail1_2	en	error:21071065:PKCS7 routines:PKCS7_signatureVerify:digest failure
+error:21071065:PKCS7 routines:func(113):reason(101)	expressoMail1_2	en	error:21071065:PKCS7 routines:func(113):reason(101)
+error:21075069:PKCS7 routines:func(117):reason(105)	expressoMail1_2	en	error:21075069:PKCS7 routines:func(117):reason(105)
 Exclusion	expressoMail1_2	en	Exclusion
 Export	expressoMail1_2	en	Export
@@ -145,4 +167,5 @@
 Insert signature automatically in new messages?	expressoMail1_2	en	Insert signature automatically in new messages?
 insertunorderedlist	expressoMail1_2	en	Insert unordered list
+Invalid signature	expressoMail1_2	en	Invalid signature
 in this message	expressoMail1_2	en	in this message
 italic	expressoMail1_2	en	italic
@@ -169,4 +192,5 @@
 Loading	expressoMail1_2	en	Loading
 Mailbox Sharing	expressoMail1_2	en	Mailbox Sharing
+Mail from: 	expressoMail1_2	pt-br	Mail from:
 Manager your folders and export messages	expressoMail1_2	en	Manager your folders and export messages
 Mark as	expressoMail1_2	en	Mark as
@@ -176,4 +200,5 @@
 Medium	expressoMail1_2	en	Medium
 Message body	expressoMail1_2	en	Message body
+Message date: 	expressoMail1_2	pt-br	Message date:
 message	expressoMail1_2	en	message
 minute ago	expressoMail1_2	en	minute ago
@@ -183,8 +208,12 @@
 Message Header	expressoMail1_2	en	Message Header
 Message marked as 	expressoMail1_2	en	Message marked as 
+Message signed by: 	expressoMail1_2	pt-br	Message signed by:
+Message untouched	expressoMail1_2	pt-br	Message untouched
 message(s) deleted from your trash folder.	expressoMail1_2	en	message(s) deleted from your trash folder.
 messages	expressoMail1_2	en	messages
 messages found in folder:	expressoMail1_2	en	messages found in folder:
 Messages saved in %1 folder.	expressoMail1_2	en	Messages saved in %1 folder.
+#MSG010- Erro verificando Expiracao/CAs do certificado.	expressoMail1_2	en	#MSG010- Erro verificando Expiracao/CAs do certificado.
+#MSG011- Ocorreu erro validando o certificado.	expressoMail1_2	en	#MSG011- Ocorreu erro validando o certificado.
 More actions	expressoMail1_2	en	More actions
 More	expressoMail1_2	en	More
@@ -316,4 +345,5 @@
 The message was moved to folder 	expressoMail1_2	en	The message was moved to folder 
 The origin folder and the destination folder are the same.	expressoMail1_2	en	The origin folder and the destination folder are the same.
+The preference "%1" isn't enabled.	expressoMail1_2	en	The preference "%1" isn't enabled.
 There's an action processing. Do you want abort it?	expressoMail1_2	en	There's an action processing. Do you want abort it?
 The results were found in the Global Catalog	expressoMail1_2	en	The results were found in the Global Catalog
@@ -345,4 +375,5 @@
 User not registered	instant_messenger	en	User not registered
 Users	expressoMail1_2	en	Users
+Validity of certificate: 	expressoMail1_2	en	Validity of certificate:
 View HTML source	expressoMail1_2	en	View HTML source
 View tips	expressoMail1_2	en	View tips
@@ -353,4 +384,5 @@
 Who	expressoMail1_2	en	Who
 With all	expressoMail1_2	en	With all
+with signer different from sender	expressoMail1_2	en	with signer different from sender
 Without Quota	expressoMail1_2	en	Without Quota
 without save	expressoMail1_2	en	without save
Index: /trunk/expressoMail1_2/setup/tables_current.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/tables_current.inc.php	(revision 468)
+++ /trunk/expressoMail1_2/setup/tables_current.inc.php	(revision 1035)
@@ -19,4 +19,18 @@
 			'ix' => array(),
 			'uc' => array()
+		),
+        'phpgw_certificados' => array(
+            'fd' => array(
+                'email' => array( 'type' => 'varchar', 'precision' => 60, 'nullable' => false),
+                'chave_publica' => array( 'type' => 'text'),
+                'expirado' => array('type' => 'bool', 'default' => 'false'),
+                'revogado' => array('type' => 'bool', 'default' => 'false'),
+                'serialnumber' => array('type' => 'int', 'precision' => 8, 'nullable' => false),
+                'authoritykeyidentifier' => array( 'type' => 'text', 'nullable' => false),
+            ),
+            'pk' => array('email','serialnumber','authoritykeyidentifier'),
+            'fk' => array(),
+            'ix' => array(),
+            'uc' => array()
 		)
 	);
Index: /trunk/expressoMail1_2/setup/tables_update.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 1034)
+++ /trunk/expressoMail1_2/setup/tables_update.inc.php	(revision 1035)
@@ -12,6 +12,35 @@
 		$test[] = '1.233';
 		function expressoMail1_2_upgrade1_233() {
-			$setup_info['expressoMail1_2']['currentver'] = '1.234';
-			return $setup_info['expressoMail1_2']['currentver'];
+            $oProc = $GLOBALS['phpgw_setup']->oProc;
+            $oProc->CreateTable('phpgw_expressomail_contacts',array(
+				'fd' => array(
+					'id_owner' => array( 'type' => 'int', 'precision' => 8, 'nullable' => false),
+					'data' => array( 'type' => 'text')
+				),
+				'pk' => array('id_owner'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+
+            $oProc->CreateTable('phpgw_certificados',array(
+				'fd' => array(
+					'email' => array( 'type' => 'varchar', 'precision' => 60, 'nullable' => false),
+					'chave_publica' => array( 'type' => 'text'),
+					'expirado' => array('type' => 'bool', 'default' => 'false'),
+					'revogado' => array('type' => 'bool', 'default' => 'false'),
+					'serialnumber' => array('type' => 'int', 'precision' => 8, 'nullable' => false),
+					'authoritykeyidentifier' => array( 'type' => 'text', 'nullable' => false),
+				),
+				'pk' => array('email','serialnumber','authoritykeyidentifier'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+
+            $GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '1.334';
+            return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
 		}
 	}	
@@ -53,9 +82,63 @@
 	if ($GLOBALS['setup_info']['expressoMail1_2']['currentver'] == '1.222'){
 		$test[] = '1.222';
-		function expressoMail1_2_upgrade1_222() {return expressoMail1_2_upgrade1_230();	}
+		function expressoMail1_2_upgrade1_222() {
+			$oProc = $GLOBALS['phpgw_setup']->oProc;
+			$oProc->CreateTable('phpgw_expressomail_contacts',array(
+				'fd' => array(
+					'id_owner' => array( 'type' => 'int', 'precision' => 8, 'nullable' => false),
+					'data' => array( 'type' => 'text')
+				),
+				'pk' => array('id_owner'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$oProc->CreateTable('phpgw_certificados',array(
+				'fd' => array(
+					'email' => array( 'type' => 'varchar', 'precision' => 60, 'nullable' => false),
+					'chave_publica' => array( 'type' => 'text'),
+					'expirado' => array('type' => 'bool', 'default' => 'false')
+				),
+				'pk' => array('email'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '1.223';
+			return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
+        }
 	}
 	if ($GLOBALS['setup_info']['expressoMail1_2']['currentver'] == '1.2211'){
 		$test[] = '1.2211';
-		function expressoMail1_2_upgrade1_2211() {return expressoMail1_2_upgrade1_230();}
+		function expressoMail1_2_upgrade1_2211() {
+			$oProc = $GLOBALS['phpgw_setup']->oProc;
+			$oProc->CreateTable('phpgw_expressomail_contacts',array(
+				'fd' => array(
+					'id_owner' => array( 'type' => 'int', 'precision' => 8, 'nullable' => false),
+					'data' => array( 'type' => 'text')
+				),
+				'pk' => array('id_owner'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$oProc->CreateTable('phpgw_certificados',array(
+				'fd' => array(
+					'email' => array( 'type' => 'varchar', 'precision' => 60, 'nullable' => false),
+					'chave_publica' => array( 'type' => 'text'),
+					'expirado' => array('type' => 'bool', 'default' => 'false')
+				),
+				'pk' => array('email'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '1.223';
+			return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
+        }
 	}
 	if ($GLOBALS['setup_info']['expressoMail1_2']['currentver'] == '1.2201'){
@@ -66,5 +149,32 @@
 	if ($GLOBALS['setup_info']['expressoMail1_2']['currentver'] == '1.2031'){
 		$test[] = '1.2031';
-		function expressoMail1_2_upgrade1_2031() {return expressoMail1_2_upgrade1_230();}
+		function expressoMail1_2_upgrade1_2031() {
+			$oProc = $GLOBALS['phpgw_setup']->oProc;
+			$oProc->CreateTable('phpgw_expressomail_contacts',array(
+				'fd' => array(
+					'id_owner' => array( 'type' => 'int', 'precision' => 8, 'nullable' => false),
+					'data' => array( 'type' => 'text')
+				),
+				'pk' => array('id_owner'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$oProc->CreateTable('phpgw_certificados',array(
+				'fd' => array(
+					'email' => array( 'type' => 'varchar', 'precision' => 60, 'nullable' => false),
+					'chave_publica' => array( 'type' => 'text'),
+					'expirado' => array('type' => 'bool', 'default' => 'false')
+				),
+				'pk' => array('email'),
+				'fk' => array(),
+				'ix' => array(),
+				'uc' => array()
+				)
+			);
+			$GLOBALS['setup_info']['expressoMail1_2']['currentver'] = '1.223';
+			return $GLOBALS['setup_info']['expressoMail1_2']['currentver'];
+        }
 	}	
 ?>
Index: /trunk/expressoMail1_2/setup/setup.inc.php
===================================================================
--- /trunk/expressoMail1_2/setup/setup.inc.php	(revision 1034)
+++ /trunk/expressoMail1_2/setup/setup.inc.php	(revision 1035)
@@ -12,7 +12,8 @@
 	$setup_info['expressoMail1_2']['name']      	= 'expressoMail1_2';
 	$setup_info['expressoMail1_2']['title']     	= 'ExpressoMail 1.2';
-	$setup_info['expressoMail1_2']['version']   	= '1.234';
+	$setup_info['expressoMail1_2']['version']   	= '1.334';
 	$setup_info['expressoMail1_2']['app_order'] 	= 2;
 	$setup_info['expressoMail1_2']['tables'][]		= 'phpgw_expressomail_contacts';
+    $setup_info['expressoMail1_2']['tables'][]		= 'phpgw_certificados';
 	$setup_info['expressoMail1_2']['enable']    	= 1;
 
Index: /trunk/expressoMail1_2/preferences.php
===================================================================
--- /trunk/expressoMail1_2/preferences.php	(revision 689)
+++ /trunk/expressoMail1_2/preferences.php	(revision 1035)
@@ -77,4 +77,37 @@
 		else
 			$GLOBALS['phpgw']->template->set_var('checked_auto_save_draft','');
+
+
+        if($GLOBALS['phpgw_info']['server']['use_assinar_criptografar'])
+		{
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_digital_cripto'])
+			{
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_digital_cripto','checked');
+			$GLOBALS['phpgw']->template->set_var('display_digital','');
+			$GLOBALS['phpgw']->template->set_var('display_cripto','');
+			}
+		else
+			{
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_digital','');
+			$GLOBALS['phpgw']->template->set_var('display_digital','style="display: none;"');
+			$GLOBALS['phpgw']->template->set_var('display_cripto','style="display: none;"');
+			}
+
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_digital'])
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_digital','checked');
+		else
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_digital','');
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_cripto'])
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_cripto','checked');
+		else
+			$GLOBALS['phpgw']->template->set_var('checked_use_signature_cripto','');
+		}
+		else
+		{
+			$GLOBALS['phpgw']->template->set_var('display_digital','style="display: none;"');
+			$GLOBALS['phpgw']->template->set_var('display_cripto','style="display: none;"');
+			$GLOBALS['phpgw']->template->set_var('display_digital_cripto','style="display: none;"');
+		}
+
 
 		// Insert new expressoMail preference use_signature: defines if the signature will be automatically inserted
@@ -223,4 +256,19 @@
 			$GLOBALS['phpgw']->preferences->add('expressoMail','auto_save_draft',$_POST['auto_save_draft']);	
 
+        if($GLOBALS['phpgw_info']['server']['use_assinar_criptografar'])
+		{
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_digital_cripto'])
+			$GLOBALS['phpgw']->preferences->change('expressoMail','use_signature_digital_cripto',$_POST['use_signature_digital_cripto']);
+		else
+			$GLOBALS['phpgw']->preferences->add('expressoMail','use_signature_digital_cripto',$_POST['use_signature_digital_cripto']);
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_digital'])
+			$GLOBALS['phpgw']->preferences->change('expressoMail','use_signature_digital',$_POST['use_signature_digital']);
+		else
+			$GLOBALS['phpgw']->preferences->add('expressoMail','use_signature_digital',$_POST['use_signature_digital']);
+		if ($GLOBALS['phpgw_info']['user']['preferences']['expressoMail']['use_signature_cripto'])
+			$GLOBALS['phpgw']->preferences->change('expressoMail','use_signature_cripto',$_POST['use_signature_cripto']);
+		else
+			$GLOBALS['phpgw']->preferences->add('expressoMail','use_signature_cripto',$_POST['use_signature_cripto']);
+		}
 		// Insert new expressoMail preference use_signature: defines if the signature will be automatically inserted
 		// at the e-mail body
@@ -312,9 +360,14 @@
 	$GLOBALS['phpgw']->template->set_var('lang_type_signature',lang('Signature type'));
 	$GLOBALS['phpgw']->template->set_var('big',lang('Big'));
+    //$GLOBALS['phpgw']->template->set_var('lang_use_signature_digital_cripto',lang('Possibilitar <b>assinar/criptografar</b> digitalmente a mensagem?'));
+	$GLOBALS['phpgw']->template->set_var('lang_use_signature_digital_cripto',lang('Enable digitally sign/cipher the message?'));
+	$GLOBALS['phpgw']->template->set_var('lang_use_signature_digital',lang('Always sign message digitally?'));
+	$GLOBALS['phpgw']->template->set_var('lang_use_signature_cripto',lang('Always cipher message digitally?'));
+	$GLOBALS['phpgw']->template->set_var('lang_use_signature',lang('Insert signature automatically in new messages?'));
+	$GLOBALS['phpgw']->template->set_var('lang_signature',lang('Signature'));
 	$GLOBALS['phpgw']->template->set_var('lang_Would_you_like_to_keep_archived_messages_?',lang('Would you like to keep archived messages?'));
 	$GLOBALS['phpgw']->template->set_var('lang_Yes',lang('Yes'));
 	$GLOBALS['phpgw']->template->set_var('lang_No',lang('No'));
 	$GLOBALS['phpgw']->template->set_var('lang_Would_you_like_to_use_local_messages_?',lang('Would you like to use local messages?'));
-	$GLOBALS['phpgw']->template->set_var('lang_use_signature',lang('Insert signature automatically in new messages?'));
 
 	$boemailadmin	= CreateObject('emailadmin.bo');
Index: /trunk/expressoMail1_2/inc/class.db_functions.inc.php
===================================================================
--- /trunk/expressoMail1_2/inc/class.db_functions.inc.php	(revision 906)
+++ /trunk/expressoMail1_2/inc/class.db_functions.inc.php	(revision 1035)
@@ -407,5 +407,71 @@
 		return $uiicalendar = $uiicalendar->import_from_mail($calendar);
 	}
-	
+
+    function insert_certificate($email,$certificate,$serialnumber,$authoritykeyidentifier=null)
+	{
+		if(!$email || !$certificate || !$serialnumber || !$authoritykeyidentifier)
+			return false;
+		// Insere uma chave publica na tabela phpgw_certificados.
+		$data = array	('email' => $email,
+						 'chave_publica' => $certificate,
+						 'serialnumber' => $serialnumber,
+						 'authoritykeyidentifier' => $authoritykeyidentifier);
+
+		if(!$this->db->insert('phpgw_certificados',$data,array(),__LINE__,__FILE__)){
+          	return $this->db->Error;
+        }
+    	return true;
+	}
+
+	function get_certificate($email=null)
+	{
+		if(!$email) return false;
+		$result = array();
+
+		$where = array ('email' => $email,
+						'revogado' => 0,
+						'expirado' => 0);
+
+ 		if(!$this->db->select('phpgw_certificados','chave_publica', $where, __LINE__,__FILE__))
+        {
+            $result['dberr1'] = $this->db->Error;
+            return $result;
+        }
+		$regs = array();
+		while($this->db->next_record())
+        {
+            $regs[] = $this->db->row();
+        }
+		if (count($regs) == 0)
+        {
+            $result['dberr2'] = ' Certificado nao localizado.';
+            return $result;
+        }
+		$result['certs'] = $regs;
+		return $result;
+	}
+
+	function update_certificate($serialnumber=null,$email=null,$authoritykeyidentifier,$expirado,$revogado)
+	{
+		if(!$email || !$serialnumber) return false;
+		if(!$expirado)
+			$expirado = 0;
+		if(!$revogado)
+			$revogado = 0;
+
+		$data = array	('expirado' => $expirado,
+						 'revogado' => $revogado);
+
+		$where = array	('email' => $email,
+						 'serialnumber' => $serialnumber,
+						 'authoritykeyidentifier' => $authoritykeyidentifier);
+
+		if(!$this->db->update('phpgw_certificados',$data,$where,__LINE__,__FILE__))
+		{
+			return $this->db->Error;
+		}
+		return true;
+	}
+
 }
 ?>
